/****************************************************************************
yws_common_plugin 通讯协议：
一、html—>websocket server
1、设置窗口尺寸
格式：[01]窗口宽度,窗口高度
例子：[01]320,240

2、切换摄像头
格式：[02]摄像头序号
例子：[02]0

3、得到摄像头列表
格式：[03]
例子：[03]

4、得到摄像头分辨率列表
格式：[04]摄像头序号
例子：[04]0

5、切换摄像头分辨率
格式：[05]摄像头序号,分辨率序号
例子：[05]0,1

6、得到当前摄像头序号,分辨率序号,打开方式序号,初始角度序号
格式：[06]
例子：[06]

7、当前摄像头抓图
格式：[07]顺时针旋转角度
例子：[07]90

8、设置图片格式
格式：[08]图片格式（jpg（默认）、bmp、tif、png、pdf）
例子：[08]tif

9、设置图片压缩比率
格式：[09]图片压缩比率（1-100，默认100）
例子：[09]50

10、设置色彩模式
格式：[10]色彩模式（color-彩色（默认），gray-灰度，black-黑白）
例子：[10]gray

11、扫描二维码
格式：[11]start/stop
例子：[11]start     --开始扫描二维码
     [11]stop      --停止扫描二维码

12、得到摄像头打开方式列表
格式：[12]
例子：[12]

13、改变摄像头打开方式
格式：[13]摄像头序号,打开方式序号
例子：[13]0,1

15、是否去红章（默认是否）*
格式：[15]0(不去红章,默认)/1,160(去红章,阈值)
例子：[15]1;160

16、是否影像矫正（默认是否）*
格式：[16]0(不影像矫正,默认)/1(影像矫正)
例子：[16]1

17、是否自动切边（默认是否）*
格式：[17]0(不自动切边,默认)/1,2(自动切边,矩形框线宽)
例子：[17]1

20、录像操作*
格式：[20]操作命令(0-查询录像状态/1-主头开始录像/2-副头开始录像/3-停止录像)

21、得到麦克风列表*
格式：[21]
例子：[21]

22、切换麦克风*
格式：[22]麦克风序号
例子：[22]1

23、是否录音（默认是）*
格式：[23]0(不录音)/1(录音,默认)
例子：[23]1

24、删除本地文件
格式：[24]本地文件带路径全名
例子：[24]E:/tmp/1.jpg

25、当前摄像头抓图2
格式：[25]顺时针旋转角度
例子：[25]90

26、设置初始角度
格式：[26]初始角度(0-0度(默认值)/1-90度/2-180度/3-270度)
例子：[26]1
注意：不带任何参数，表示获得初始化角度

27、是否保持宽高比（默认是）
格式：[27]1(是)/0(否)
例子：[27]1

28、得到拍照存储目录
格式：[28]
例子：[28]

29、设置拍照存储目录
格式：[29]拍照存储目录
例子：[29]/home/chentao/pic

30、得到拍照命名方式
格式：[30]
例子：[30]

31、设置拍照命名方式
格式：[31]拍照命名方式(0-时间命名，1-序号命名)
例子：[31]1

34、得到图片格式、图片压缩比率
格式：[34]图片格式（jpg、tif、png）,图片压缩比率（1-100）
例子：[34]tif

二、websocket server—>html
1、摄像头列表
格式：[03]摄像头序号:摄像头名称,摄像头序号:摄像头名称
例子：[03]0:主摄像头,1:副摄像头

2、摄像头分辨率列表
格式：[04]摄像头序号;分辨率序号:分辨率,分辨率序号:分辨率
例子：[04]0;0:640x480,1:1024x768

3、当前摄像头序号,分辨率序号,打开方式序号,初始角度序号,是否保持宽高比
格式：[06]摄像头序号,分辨率序号,打开方式序号,是否保持宽高比
例子：[06]0,1,0,0,1

4、当前摄像头抓图反馈
格式：[07]文件带路径名称
例子：[07]D:\20200918.jpg

5、设备已拔出
格式：[08]
例子：[08]

5、设备已插入setlogo
格式：[09]
例子：[09]

7、摄像头打开方式列表
格式：[12]打开方式序号:打开方式,打开方式序号:打开方式
例子：[12]0:YUV,1:MJPG

8、是否去红章（默认是否）
格式：[15]0(不去红章,默认)/1,160(去红章,阈值)
例子：[15]1;160

9、是否影像矫正（默认是否）
格式：[16]0(不影像矫正,默认)/1(影像矫正)
例子：[16]1

10、是否自动切边（默认是否）
格式：[17]0(不自动切边,默认)/1,2(自动切边,矩形框线宽)
例子：[17]1,2

13、录像信息反馈
格式：[20]状态(0-未录像/1-主头录像中/2-副头录像中/3-主头开始录像失败/4-副头开始录像失败/5-停止录像失败),时长(秒,状态为1/2时才有)/操作失败原因(状态为3/4/5/6时才有),录像文件名(状态为1/2时才有)
例子：[20]1,198,/home/chentao/work/echoserver/build/kylin/yws_plugin/2020_12_04_110946.avi
     [20]0
     [20]3,can not start record when recording
     [20]3,this camera doesn't exist
     [20]5,can not stop record when no recording

15、麦克风列表
格式：[21]麦克风序号:麦克风名称,麦克风序号:麦克风名称
例子：[21]1:microphone0,2:microphone1

16、是否录音（默认是）
格式：[23]0(不录音)/1(录音,默认)
例子：[23]1

24、删除本地文件反馈
格式：[24]删除结果(0-成功，1-失败),本地文件带路径全名
例子：[24]E:/tmp/1.jpg

25、当前摄像头抓图2反馈
格式：[25]结果(0-成功，1-失败),图片宽,图片高,base64字符串
例子：[25]0,1920,1080,AB1F29d36......
     [25]1

26、当前初始角度反馈
格式：[26]初始角度(0-0度(默认值)/1-90度/2-180度/3-270度)
例子：[26]1

28、拍照存储目录反馈
格式：[28]拍照存储目录
例子：[28]/home/chentao/pic

30、拍照命名方式反馈
格式：[30]拍照命名方式(0-时间命名，1-序号命名)
例子：[30]0


34、图片格式、图片压缩比率反馈
格式：[34]图片格式（jpg、bmp、tif、png、pdf）,图片压缩比率（1-100）
例子：[34]jgp,100


****************************************************************************/
	var g_websocket = null;
	var g_wsUri = "ws:localhost:10021";
	var g_width = 640;
	var g_height = 480;
	var g_angle = 0;
	var g_isMove = false;
	var g_X, g_Y;
	var g_mouseX, g_mouseY;
    var g_recordStatus = 0;//0-没录像 1-主头录像中 2-副头录像中
    var g_grabimgpatharr =null;  // 存储截图图像文件路径的数组
    var g_imgsavepath = null;    //存储图片的路径

function mousedown(e) {
	video_div = document.getElementById("video_div");

	g_isMove = true;
	
	g_X = e.pageX - parseInt(video_div.offsetLeft);
	g_Y = e.pageY - parseInt(video_div.offsetTop);
}

function mouseup(e) {
	g_isMove = false;
}

function mousemove(e) {
	video_div = document.getElementById("video_div");

	g_mouseX = e.pageX;
	g_mouseY = e.pageY;
	if (g_isMove) {
		var left = e.pageX - g_X;
		var top = e.pageY - g_Y;
		video_div.style.left = left + 'px';
		video_div.style.top = top + 'px';
	}
}		 
	
function connectAttachListeners() {
	var x = document.querySelectorAll('.disable');
	for(var i=0; i<x.length; i++){
		x[i].disabled = true;
	}

	document.getElementById('connect').addEventListener('click', function() { connect(); });
	document.getElementById('disconnect').addEventListener('click', function() { disconnect(); });
	document.getElementById('grab').addEventListener('click', function() { grab(); });
    document.getElementById('grab2').addEventListener('click', function() { grab2(); });
    document.getElementById('change_window_size').addEventListener('click', function() { changeWindowsSize(); });
	document.getElementById('rotate_window').addEventListener('click', function() { rotateWindows(); });
    document.getElementById('keepaspect').addEventListener('click', function() { keepAspect(); });
    document.getElementById('rectify').addEventListener('click', function() { rectify(); });
    document.getElementById('autoTrim').addEventListener('click', function() { autoTrim(); });
    document.getElementById('lineWidth').onchange = function() { autoTrim(); };
    document.getElementById('video_div').addEventListener('mousedown', mousedown);
	document.getElementById('video_div').addEventListener('mouseup', mouseup);
	document.addEventListener('mousemove', mousemove);
    document.getElementById('recordInfo').addEventListener('click', function() { recordInfo(); });
    document.getElementById('mainRecord').addEventListener('click', function() { mainRecord(); });
    document.getElementById('secondRecord').addEventListener('click', function() { secondRecord(); });
    document.getElementById('stopRecord').addEventListener('click', function() { stopRecord(); });
    document.getElementById('bRecordAudio').addEventListener('click', function() { bRecordAudio(); });
    document.getElementById('deleteFile').addEventListener('click', function() { deleteFile(); });
    document.getElementById('timeMode').addEventListener('click', function() { timeMode(); }); //时间模式命名图片 
    document.getElementById('indexMode').addEventListener('click', function() { indexMode(); }); //序号模式

  	var cameraSelect = document.querySelector('select#camera');
	cameraSelect.onchange = switchCamera;

    var microphoneSelect = document.querySelector('select#microphone');
    microphoneSelect.onchange = switchMicrophone;

    var solutionSelect = document.querySelector('select#solution');
	solutionSelect.onchange = switchSolution;
	
    var openmodeSelect = document.querySelector('select#openmode');
    openmodeSelect.onchange = switchOpenmode;

    var initangleSelect = document.querySelector('select#initangle');
    const optionTmp = document.createElement('option');
    optionTmp.value = "0";
    optionTmp.text = "0度";
    initangleSelect.appendChild(optionTmp);
    const optionTmp1 = document.createElement('option');
    optionTmp1.value = "1";
    optionTmp1.text = "90度";
    initangleSelect.appendChild(optionTmp1);
    const optionTmp2 = document.createElement('option');
    optionTmp2.value = "2";
    optionTmp2.text = "180度";
    initangleSelect.appendChild(optionTmp2);
    const optionTmp3 = document.createElement('option');
    optionTmp3.value = "3";
    optionTmp3.text = "270度";
    initangleSelect.appendChild(optionTmp3);
    initangleSelect.onchange = switchInitangle;

    var pictureformatSelect = document.querySelector('select#pictureformat');
	const option = document.createElement('option');
	option.value = "jpg";
	option.text = "jpg";
	pictureformatSelect.appendChild(option);
    const option01 = document.createElement('option');
    option01.value = "bmp";
    option01.text = "bmp";
    pictureformatSelect.appendChild(option01);
    const option1 = document.createElement('option');
	option1.value = "tif";
	option1.text = "tif";
	pictureformatSelect.appendChild(option1);
	const option2 = document.createElement('option');
	option2.value = "png";
    option2.text = "png";
	pictureformatSelect.appendChild(option2);
	pictureformatSelect.onchange = switchPictureFormat;
	
	var colormodeSelect = document.querySelector('select#colormode');
	const option5 = document.createElement('option');
	option5.value = "color";
	option5.text = "彩色";
	colormodeSelect.appendChild(option5);
	const option6 = document.createElement('option');
	option6.value = "gray";
    option6.text = "灰度";
	colormodeSelect.appendChild(option6);
    const option7 = document.createElement('option');
    option7.value = "black";
    option7.text = "黑白";
    colormodeSelect.appendChild(option7);
    colormodeSelect.onchange = switchColorMode;
	
	document.getElementById('setpicturepressratio').addEventListener('click', function() { setPicturePressRatio(); });
    document.getElementById('setpicturesavepath').addEventListener('click', function() { setPictureSavePath(); });
    document.getElementById('setnextpictureindex').addEventListener('click', function() { setNextPictureIndex(); });
}

function rotateWindows() {
	var video_div = document.getElementById("video_div");
	var rotate = document.getElementById('rotate');
	g_angle = rotate.value;
	
	console.log("rotateWindows:",rotate.value);
	if("transform" in video_div.style){
		var str_rotate = "rotate("+rotate.value+"deg)";
		video_div.style.transform = str_rotate;
	}else{
		console.log("style.transform not be souported");
		//		var str_rotate = "rotate("+rotate.value+"deg)";
		//video_div.style.transform = str_rotate;
	}
}
function indexMode() {
    var timeMode = document.getElementById("timeMode");

    var command = "[31]"
    if(timeMode.checked){
        command += "0";
        setnextpictureindex.disabled = true;
        nextpictureindex.disabled = true;
    }else{
        command += "1";
        setnextpictureindex.disabled = false;
        nextpictureindex.disabled = false;
    }
    g_websocket.send(command);
}
/*
function removeRed() {
    var removeRed = document.getElementById("remove_red");
    var removeRedThreshold = document.getElementById('removeRedThreshold');

    console.log("removeRed:",removeRed.checked,removeRedThreshold.value);
    var command = "[15]";
    if(removeRed.checked){
        command += "1,";
        command += removeRedThreshold.value;
    }else{
        command += "0";
    }
    g_websocket.send(command);
}*/

function timeMode() {
    var timeMode = document.getElementById("timeMode");
    var setnextpictureindex = document.getElementById("setnextpictureindex");
    var nextpictureindex = document.getElementById("nextpictureindex");
    console.log("timeMode:", setnextpictureindex.value,nextpictureindex.value);
    var command = "[31]"
    if(timeMode.checked){
        command += "0";
        setnextpictureindex.disabled = true;
        nextpictureindex = true;
    }else{
        command += "1";
        setnextpictureindex.disabled = false;
        nextpictureindex = false;
    }
    g_websocket.send(command);
}

function keepAspect() {
    var keepaspect = document.getElementById("keepaspect");

    console.log("keepAspect:",keepAspect.checked);
    var command = "[27]";
    if(keepaspect.checked){
        command += "1";
    }else{
        command += "0";
    }
    g_websocket.send(command);
}

function rectify() {
    var rectify = document.getElementById("rectify");
    var rotate = document.getElementById("rotate");
    var autoTrim = document.getElementById("autoTrim");

    console.log("rectify:",rectify.checked);
    var command = "[16]";
    if(rectify.checked){
        command += "1";
        //影像矫正时不允许旋转窗口
        rotate.value = 0;
        rotateWindows();
        rotate.disabled = true;
    }else{
        command += "0";
        if(!autoTrim.checked){
            rotate.disabled = false;
        }
    }
    g_websocket.send(command);
}

function bRecordAudio() {
    var bRecordAudio = document.getElementById("bRecordAudio");

    console.log("bRecordAudio:",bRecordAudio.checked);
    var command = "[23]";
    if(bRecordAudio.checked){
        command += "1";
    }else{
        command += "0";
    }
    g_websocket.send(command);
}

function autoTrim() {
    var autoTrim = document.getElementById("autoTrim");
    var lineWidth = document.getElementById('lineWidth');
    var rotate = document.getElementById("rotate");
    var rectify = document.getElementById("rectify");

    console.log("autoTrim:",autoTrim.checked,lineWidth.value);
    var command = "[17]";
    if(autoTrim.checked){
        command += "1,";
        command += lineWidth.value;
        //自动切边时不允许旋转窗口
        rotate.value = 0;
        rotateWindows();
        rotate.disabled = true;
    }else{
        command += "0";
        if(!rectify.checked){
            rotate.disabled = false;
        }
    }
    g_websocket.send(command);
}

function mainRecord() {
    if(g_recordStatus==0){
        var command = "[20]";
        command += "1";
        g_websocket.send(command);
    }
}

function secondRecord() {
    if(g_recordStatus==0){
        var command = "[20]";
        command += "2";
        g_websocket.send(command);
    }
}

function stopRecord() {
    if(g_recordStatus==1 || g_recordStatus==2){
        var command = "[20]";
        command += "3";
        g_websocket.send(command);
    }
}

function recordInfo() {
    var command = "[20]";
    command += "0";
    g_websocket.send(command);
}

function changeWindowsSize() {
	var videoWidth = document.getElementById('videoWidth');
	var videoHeight = document.getElementById('videoHeight');
	var cameraVideo = document.getElementById('cameraVideo');

	console.log("changeWindowsSize:",videoWidth.value,videoHeight.value);
	cameraVideo.width = videoWidth.value;
	cameraVideo.height = videoHeight.value;

	//计算缩放比例
	var video_ratio = parseInt(videoWidth.value*100/g_width);
	document.getElementById("videoPercent").innerHTML = video_ratio+ "%";
	
	var command = "[01]";
	command += videoWidth.value;
	command += ",";
	command += videoHeight.value;
	g_websocket.send(command);
}

function drawVideo(picture){
	var cameraVideo = document.getElementById("cameraVideo");  
	var cameraVideoCtx = cameraVideo.getContext("2d");
	cameraVideoCtx.drawImage(picture, 0, 0);
}

function drawGrab2Picture(width, height, picture){
    var grab2pictureCanvas = document.getElementById("grab2pictureCanvas");
    grab2pictureCanvas.width = width;
    grab2pictureCanvas.height = height;
    var grab2pictureCanvasCtx = grab2pictureCanvas.getContext("2d");
    grab2pictureCanvasCtx.drawImage(picture, 0, 0);
}

function getCameraList() {
	g_websocket.send("[03]");
}

function switchSolution() {
	var cameraSelect = document.querySelector('select#camera');
	const cameraIndex = cameraSelect.value;
	var solutionSelect = document.querySelector('select#solution');
	const solutionIndex = solutionSelect.value;
/*
	//切换摄像头
	var command1 = "[02]" + cameraIndex;
	g_websocket.send(command1);
*/
	//切换摄像头的分辨率
	var command2 = "[05]" + cameraIndex + "," + solutionIndex;
	g_websocket.send(command2);
	
	var index = solutionSelect.selectedIndex;
	var solution = solutionSelect.options[index].text;
	console.log("switchSolution:",solution);
	var list1 = solution.split("x");
	g_width = list1[0];
	g_height = list1[1];
}

function switchOpenmode() {
    var cameraSelect = document.querySelector('select#camera');
    const cameraIndex = cameraSelect.value;
    var openmodeSelect = document.querySelector('select#openmode');
    const openmodeIndex = openmodeSelect.value;

    //切换摄像头打开方式
    var command1 = "[13]" + cameraIndex + "," + openmodeIndex;
    g_websocket.send(command1);
}

function switchCamera() {
	var cameraSelect = document.querySelector('select#camera');
	const cameraIndex = cameraSelect.value;

	//切换摄像头
	var command = "[02]" + cameraIndex;
	g_websocket.send(command);

	//取新摄像头的分辨率列表
	var command = "[04]" + cameraIndex;
	g_websocket.send(command);

    //得到当前摄像头序号，分辨率序号,打开方式序号
    var command = "[06]";
    g_websocket.send(command);
}

function switchMicrophone() {
    var microphoneSelect = document.querySelector('select#microphone');
    const microphoneIndex = microphoneSelect.value;

    //切换麦克风
    var command = "[22]" + microphoneIndex;
    g_websocket.send(command);
}

function getSolutionList() {
	var cameraSelect = document.querySelector('select#camera');
	const cameraIndex = cameraSelect.value;
	
	var command = "[04]" + cameraIndex;
	g_websocket.send(command);
}

function grab() {
    if(g_imgsavepath ==null)
    {   alert("请设置图片存储目录");
        return;
    }
 ///   removeRed();
    console.log("grab:", g_angle);
	var command = "[07]" + g_angle;
	g_websocket.send(command);
}

function grab2() {
//    removeRed();
    console.log("grab2:", g_angle);
    var command = "[25]" + g_angle;
    g_websocket.send(command);
}

var receive = [];

function connect() {
	var connect = document.getElementById("connect"); 
	var disconnect = document.getElementById("disconnect"); 
	var grab = document.getElementById("grab"); 

	try {
		if (typeof MozWebSocket == 'function')
			WebSocket = MozWebSocket;
		if ( g_websocket && g_websocket.readyState == 1 )
			g_websocket.close();
		g_websocket = new WebSocket( g_wsUri );
		console.log( "Message connect 1:",g_websocket.binaryType);
		g_websocket.onopen = function (evt) {
			console.log( "CONNECTED");
			document.getElementById("connectMessage").innerHTML = "连接成功";
			connect.disabled = 'disabled';
			disconnect.disabled = '';
			grab.disabled = '';
            g_grabimgpatharr = new Array();			
			//document.querySelector('.disable').removeAttribute('disabled');
			var x = document.querySelectorAll('.disable');
			for(var i=0; i<x.length; i++){
				x[i].disabled = false;
			}
			
			g_websocket.send("[03]");//获取摄像头列表
            g_websocket.send("[21]");//获取麦克风列表
            g_websocket.send("[12]");//获取摄像头打开方式列表
            recordInfo();
            bRecordAudio();
        };
		g_websocket.onclose = function (evt) {
			console.log( "DISCONNECTED");
			document.getElementById("connectMessage").innerHTML = "连接断开";
			connect.disabled = '';
			disconnect.disabled = 'disabled';
			grab.disabled = 'disabled';
			
			var x = document.querySelectorAll('.disable');
			for(var i=0; i<x.length; i++){
				x[i].disabled = true;
			}
		};
		g_websocket.onmessage = function (evt) {
			//console.log( "Message received :", evt.data );
			if(evt.data.substr(0, 4) == "[03]"){
                console.log( "Message received [03]:", evt.data.substr(4));
				var command = evt.data.substr(4);
				var list1 = command.split(",");
				var cameraSelect = document.querySelector('select#camera');
				cameraSelect.length = 0;
				for (var i=0;i<list1.length;i++){
					var list2 = list1[i].split(":");
					var option = document.createElement('option');
					option.value = list2[0];
					option.text = list2[1];
					cameraSelect.appendChild(option);
					console.log(list1[i]);
				}
                switchCamera();//切换到当前摄像头
				document.getElementById("deviceMessage").innerHTML = "设备已插入";
			}else if(evt.data.substr(0, 4) == "[04]"){
                console.log( "Message received [04]:", evt.data.substr(4));
				var command = evt.data.substr(4);
				var list1 = command.split(";");
				var list2 = list1[1].split(",");
				var solutionSelect = document.querySelector('select#solution');
				solutionSelect.length = 0;
				for (var i=0;i<list2.length;i++){
					var list3 = list2[i].split(":");
					var option = document.createElement('option');
					option.value = list3[0];
					option.text = list3[1];
					solutionSelect.appendChild(option);
					console.log(list2[i]);
                     if(g_imgsavepath)
            {
                var picturesavepath = document.getElementById('picturesavepath');
                picturesavepath.value = g_imgsavepath;
                //设置图片存储目录
                var command1 = "[29]" + picturesavepath.value;
                g_websocket.send(command1);
            }
				}
            }else if(evt.data.substr(0, 4) == "[06]"){
                console.log( "Message received [06]:", evt.data.substr(4) );
                var command = evt.data.substr(4);
                var list1 = command.split(",");
                const cameraIndex = list1[0];
                var cameraSelect = document.querySelector('select#camera');
                cameraSelect.value = cameraIndex;
                const solutionIndex = list1[1];
                var solutionSelect = document.querySelector('select#solution');
                solutionSelect.value = solutionIndex;
                const openmodeIndex = list1[2];
                var openmodeSelect = document.querySelector('select#openmode');
                openmodeSelect.value = openmodeIndex;
                const initangle = list1[3]
                var initangleSelect = document.querySelector('select#initangle');
                initangleSelect.value = initangle;
                var command = list1[4];
                if(command=='0'){
                    document.getElementById('keepaspect').checked = false;
                }else{
                    document.getElementById('keepaspect').checked = true;
                }
            }else if(evt.data.substr(0, 4) == "[07]"){
				console.log( "Message received [07]:", evt.data.substr(4) );
                 var grabfilepath = evt.data.substr(4);
                 g_grabimgpatharr.push(grabfilepath);
                 var filepath = document.getElementById('filename');
                 filepath.value = grabfilepath;
				document.getElementById("grabMessage").innerHTML = "截图文件: "+grabfilepath;
                 
				var img = document.createElement('img');
                img.setAttribute('src','file:///'+evt.data.substr(4));
				img.setAttribute('width','240');
				img.setAttribute('height','180');
				var grabpicture = document.getElementById('grabpicture');
				console.log("first child element:", grabpicture.firstChild);
				if(grabpicture.children.length==0){
					grabpicture.appendChild(img);
				}else{
					grabpicture.insertBefore(img, grabpicture.firstChild);
				}
			}else if(evt.data.substr(0, 4) == "data"){
                //console.log("data length:", evt.data.length);
				var picture = new Image();  
				picture.src = evt.data; 
				if(picture.complete){
					drawVideo(picture);
				}else{
					picture.onload = function(){
						drawVideo(picture);
					};
					picture.onerror = function(){
						console.error( "图像加载失败:");
					};
				}	
			}else if(evt.data.substr(0, 4) == "[08]"){
				//设备拔出
                console.log( "Message received [08]:", evt.data.substr(4) );
				var cameraSelect = document.querySelector('select#camera');
				var solutionSelect = document.querySelector('select#solution');
				cameraSelect.length = 0;
				solutionSelect.length = 0;
				document.getElementById("deviceMessage").innerHTML = "设备已拔出";
			}else if(evt.data.substr(0, 4) == "[09]"){
				//设备插入
                console.log( "Message received [09]:", evt.data.substr(4) );
				g_websocket.send("[03]");//获取摄像头列表
                g_websocket.send("[21]");//获取麦克风列表
                g_websocket.send("[12]");//获取摄像头打开方式列表
                g_websocket.send("[28]");//得到拍照存储目录
                g_websocket.send("[30]");//得到拍照命名方式
                g_websocket.send("[32]");//得到下一张照片序号
                g_websocket.send("[34]");//得到图片格式、图片压缩比率
                document.getElementById("deviceMessage").innerHTML = "设备已插入";
			}else if(evt.data.substr(0,4) == "[12]"){
                console.log( "Message received [12]:", evt.data.substr(4));
                var command = evt.data.substr(4);
                var list1 = command.split(",");
                var openmodeSelect = document.querySelector('select#openmode');
                openmodeSelect.length = 0;
                for (var i=0;i<list1.length;i++){
                    var list2 = list1[i].split(":");
                    var option = document.createElement('option');
                    option.value = list2[0];
                    option.text = list2[1];
                    openmodeSelect.appendChild(option);
                    console.log(list1[i]);
                }
            }else if(evt.data.substr(0,4) == "[15]"){
                console.log( "Message received [15]:", evt.data.substr(4));
                
            }else if(evt.data.substr(0,4) == "[16]"){
                console.log( "Message received [16]:", evt.data.substr(4));
                var command = evt.data.substr(4);
                if(command=='0'){
                    document.getElementById('rectify').checked = false;
                }else if(command=='1'){
                    document.getElementById('rectify').checked = true;
                }
            }else if(evt.data.substr(0,4) == "[17]"){
                console.log( "Message received [17]:", evt.data.substr(4));
                var command = evt.data.substr(4);
                if(command=='0'){
                    document.getElementById('autoTrim').checked = false;
                }else{
                    var list1 = command.split(",");
                    if(list1[0]=='1'){
                        document.getElementById('autoTrim').checked = true;
                        document.getElementById('lineWidth').value = list1[1];
                    }
                }
            }else if(evt.data.substr(0,4) == "[20]"){
                console.log( "Message received [20]:", evt.data.substr(4));
                var command = evt.data.substr(4);
                var list1 = command.split(",");

                if(list1[0]=='0'){
                    //未录像
                    var message = "状态:未录像";
                    document.getElementById("recordMessage").innerHTML = message;
                    document.getElementById("mainRecord").disabled = false;
                    document.getElementById("secondRecord").disabled = false;
                    document.getElementById("stopRecord").disabled = true;
                    g_recordStatus = 0;
                }else if(list1[0]=='1'){
                    //主头录像中
                    var message = "状态:主头录像中,";
                    message += "时长:";
                    message += list1[1];
                    message += "秒,";
                    message += "录像文件名:";
                    message += list1[2];
                    document.getElementById("recordMessage").innerHTML = message;
                    document.getElementById("mainRecord").disabled = true;
                    document.getElementById("secondRecord").disabled = true;
                    document.getElementById("stopRecord").disabled = false;
                    g_recordStatus = 1;
                }else if(list1[0]=='2'){
                    //副头录像中
                    var message = "状态:副头录像中,";
                    message += "时长:";
                    message += list1[1];
                    message += "秒,";
                    message += "录像文件名:";
                    message += list1[2];
                    document.getElementById("recordMessage").innerHTML = message;
                    document.getElementById("mainRecord").disabled = true;
                    document.getElementById("secondRecord").disabled = true;
                    document.getElementById("stopRecord").disabled = false;
                    g_recordStatus = 2;
                }else if(list1[0]=='3'){
                    //主头开始录像失败
                    var message = "状态:主头开始录像失败,";
                    message += "操作失败原因:";
                    message += "list1[1]";
                    document.getElementById("recordMessage").innerHTML = message;
                }else if(list1[0]=='4'){
                    //副头开始录像失败
                    var message = "状态:副头开始录像失败,";
                    message += "操作失败原因:";
                    message += "list1[1]";
                    document.getElementById("recordMessage").innerHTML = message;
                }else if(list1[0]=='5'){
                     //停止录像失败
                    var message = "状态:停止录像失败,";
                    message += "操作失败原因:";
                    message += "list1[1]";
                    document.getElementById("recordMessage").innerHTML = message;
                }
            }else if(evt.data.substr(0,4) == "[21]"){
                console.log( "Message received [21]:", evt.data.substr(4));
                var command = evt.data.substr(4);
                var list1 = command.split(",");
                var microphoneSelect = document.querySelector('select#microphone');
                microphoneSelect.length = 0;
                for (var i=0;i<list1.length;i++){
                    var list2 = list1[i].split(":");
                    var option = document.createElement('option');
                    option.value = list2[0];
                    option.text = list2[1];
                    microphoneSelect.appendChild(option);
                    console.log(list1[i]);
                }
                switchMicrophone();//切换到当前麦克风
            }else if(evt.data.substr(0,4) == "[23]"){
                console.log( "Message received [23]:", evt.data.substr(4));
                var command = evt.data.substr(4);
                if(command=='0'){
                    document.getElementById('bRecordAudio').checked = false;
                }else if(command=='1'){
                    document.getElementById('bRecordAudio').checked = true;
                }
            }else if(evt.data.substr(0,4) == "[24]"){
                console.log( "Message received [24]:", evt.data.substr(4));
                var command = evt.data.substr(4);
                var list1 = command.split(",");
                if(list1[0]=='0'){
                    var grabpicture = document.getElementById('grabpicture');
                    for(var i=0;i<grabpicture.children.length;i++){
                        if(grabpicture.children[i].src.indexOf(list1[1]) > 0 ){
                            grabpicture.removeChild(grabpicture.children[i]);
                        }
                    }
                }
            }else if(evt.data.substr(0,4) == "[25]"){
                console.log( "Message received [25]");
                var command = evt.data.substr(4);
                var list1 = command.split(",");
                if(list1[0]=='0'){
                    var picture = new Image();
                    picture.src = "data:image/png;base64," + list1[3];
                    if(picture.complete){
                        drawGrab2Picture(list1[1],list1[2],picture);
                    }else{
                        picture.onload = function(){
                            drawGrab2Picture(list1[1],list1[2],picture);
                        };
                        picture.onerror = function(){
                            console.error( "图像加载失败:");
                        };
                    }
                }
            }else if(evt.data.substr(0,4) == "[28]"){
                console.log( "Message received [28]");
               // var picturesavepath = document.getElementById('picturesavepath');
               // picturesavepath.value = command;
            }else if(evt.data.substr(0,4) == "[30]"){
                console.log( "Message received [30]");
                var command = evt.data.substr(4);
                var timeMode = document.getElementById('timeMode');
                var indexMode = document.getElementById('indexMode');
                var setnextpictureindex = document.getElementById("setnextpictureindex");
                var nextpictureindex = document.getElementById("nextpictureindex");
                if(command=='0'){
                    timeMode.checked = 'true';
                    setnextpictureindex.disabled = true;
                    nextpictureindex.disabled = true;
                }else if(command='1'){
                    indexMode.checked = 'true';
                    setnextpictureindex.disabled = false;
                    nextpictureindex.disabled = false;
                }
            }else if(evt.data.substr(0,4) == "[32]"){
                console.log( "Message received [32]");
                var command = evt.data.substr(4);
                var nextpictureindex = document.getElementById('nextpictureindex');
                nextpictureindex.value = command;
            }else if(evt.data.substr(0,4) == "[34]"){
                console.log( "Message received [34]");
                var command = evt.data.substr(4);
                var list1 = command.split(",");
                var pictureformatSelect = document.querySelector('select#pictureformat');
                pictureformatSelect.value = list1[0];
                var picturepressratio = document.getElementById('picturepressratio');
                picturepressratio.value = list1[1];
            }
		};
		g_websocket.onerror = function (evt) {
			console.log( "websocket error1");
		};
	} catch (exception) {
		console.log( "websocket error2:",exception);
	}
}

        function writeToScreen(message) {
			output = document.getElementById("output");
			
            var pre = document.createElement("p");
            pre.style.wordWrap = "break-word";
            pre.innerHTML = message;
            output.appendChild(pre);
        } // write the message on the screen

function removeFile() {
   var i;
   for(i =0; i<g_grabimgpatharr.length; i++)
   {//删除所有保存的图片
    var item = g_grabimgpatharr[i];
    var command = "[24]" + item;
    g_websocket.send(command);     
   } 
   g_grabimgpatharr.splice(0,g_grabimgpatharr.length);
}
		
function disconnect() {
	try {
		if (typeof MozWebSocket == 'function')
		{
         	WebSocket = MozWebSocket;
        }
		if ( g_websocket && g_websocket.readyState == 1 )
		{
              removeFile();              
              setTimeout(function(){
              g_websocket.close();},1000);
        }
	} catch (exception) {
		console.log( "disconnect error:",exception);
	}
}

function clearNoNum(obj){
	obj.value = obj.value.replace(/[^\d.]/g,"");  //清除“数字”和“.”以外的字符
	obj.value = obj.value.replace(/^\./g,"");  //验证第一个字符是数字而不是.
	obj.value = obj.value.replace(/\.{2,}/g,"."); //只保留第一个. 清除多余的.
	obj.value = obj.value.replace(".","$#$").replace(/\./g,"").replace("$#$",".");

}

function switchPictureFormat() {
	var pictureformatSelect = document.querySelector('select#pictureformat');

	//设置图片类型
	var command1 = "[08]" + pictureformatSelect.value;
	g_websocket.send(command1);
}

function setPicturePressRatio() {
	var picturepressratio = document.getElementById('picturepressratio'); 
	
	//设置图片压缩比率
	var command1 = "[09]" + picturepressratio.value;
	g_websocket.send(command1);
}

function setPictureSavePath() {
    var picturesavepath = document.getElementById('picturesavepath');  
    if(picturesavepath.value)
    {
       g_imgsavepath = picturesavepath.value;
       alert(g_imgsavepath);
    }
    //设置图片存储目录
    var command1 = "[29]" + picturesavepath.value;
    g_websocket.send(command1);
}

function switchColorMode() {
	console.log("switchColorMode");
	var colorModeSelect = document.querySelector('select#colormode');

	//设置色彩模式
	var command1 = "[10]" + colorModeSelect.value;
	g_websocket.send(command1);
}

function switchInitangle() {
    console.log("switchInitangle");
    var initangleSelect = document.querySelector('select#initangle');
    //设置初始角度
    var command1 = "[26]" + initangleSelect.value;
    g_websocket.send(command1);
}

function deleteFile() {
    var filename = document.getElementById('filename');
    //删除图片
    var command = "[24]" + filename.value;
    alert(command);
    g_websocket.send(command);
    filename.value = "";
    document.getElementById("grabMessage").innerHTML="";
}

